import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import classnames from 'classnames';
import hljs from 'highlight.js';
import React from 'react';
import ReactMarkdown from 'react-markdown';
import "./hljs.css";
import "./index.css";
import "./markdown.css";
hljs.configure({
  classPrefix: '',
  // don't append class prefix
  tabReplace: '  ' // 2 spaces

});

var PreviewMarkdown =
/*#__PURE__*/
function (_React$Component) {
  _inherits(PreviewMarkdown, _React$Component);

  function PreviewMarkdown(props) {
    var _this;

    _classCallCheck(this, PreviewMarkdown);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PreviewMarkdown).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "node", void 0);

    _defineProperty(_assertThisInitialized(_this), "allowNode", function (node) {
      if (node.type === 'html' && node.value) {
        if (/<!--([^]+?)-->/.test(node.value)) {
          return false;
        }
      }

      return true;
    });

    _this.state = {
      value: props.value
    };
    return _this;
  }

  _createClass(PreviewMarkdown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.highlight();
    }
  }, {
    key: "highlight",
    value: function highlight() {
      var code = this.node.getElementsByTagName('code');
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = code[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var value = _step.value;
          var tag = value.parentNode;

          if (tag && tag.tagName === 'PRE') {
            hljs.highlightBlock(value);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: "updateSource",
    value: function updateSource(value) {
      var _this2 = this;

      this.setState({
        value: value
      }, function () {
        _this2.highlight();
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          visble = _this$props.visble,
          value = _this$props.value,
          elementProps = _objectWithoutProperties(_this$props, ["prefixCls", "visble", "value"]);

      return React.createElement("div", _extends({
        ref: function ref(node) {
          return _this3.node = node;
        },
        className: classnames("".concat(prefixCls, "-preview"), _defineProperty({}, "".concat(prefixCls, "-visble"), visble))
      }, elementProps), React.createElement(ReactMarkdown, {
        className: classnames("".concat(prefixCls, "-markdown")),
        source: this.state.value,
        escapeHtml: false,
        allowNode: this.allowNode
      }));
    }
  }]);

  return PreviewMarkdown;
}(React.Component);

_defineProperty(PreviewMarkdown, "defaultProps", {
  prefixCls: 'md-editor',
  visble: true
});

export { PreviewMarkdown as default };
//# sourceMappingURL=index.js.map